/*
 * Decompiled with CFR 0.152.
 * 
 * Could not load the following classes:
 *  cn.hutool.core.util.NumberUtil
 *  com.deepexi.scd.basic.domain.query.CarbonProductApiQuery
 *  com.deepexi.scd.calculate.domain.dto.CalculateProductCatalogApiDTO
 *  com.deepexi.scd.calculate.domain.query.CalculateProductCatalogApiQuery
 *  com.deepexi.scd.calculate.domain.query.CarbonFootprintQuery
 *  com.deepexi.scd.calculate.remote.basic.CarbonProductRemote
 *  com.deepexi.scd.calculate.remote.calculate.CalculateProductCatalogRemote
 *  com.deepexi.scd.calculate.service.CarbonFootprintService
 *  com.deepexi.spa.commons.data.PageBean
 *  com.deepexi.spa.commons.data.Payload
 *  com.deepexi.spa.commons.utils.CollectionUtils
 *  com.google.api.client.util.Lists
 *  io.swagger.annotations.Api
 *  io.swagger.annotations.ApiOperation
 *  org.springframework.beans.factory.annotation.Autowired
 *  org.springframework.web.bind.annotation.GetMapping
 *  org.springframework.web.bind.annotation.RequestMapping
 *  org.springframework.web.bind.annotation.RestController
 */
package com.deepexi.scd.calculate.controller;

import cn.hutool.core.util.NumberUtil;
import com.deepexi.scd.basic.domain.query.CarbonProductApiQuery;
import com.deepexi.scd.calculate.domain.dto.CalculateProductCatalogApiDTO;
import com.deepexi.scd.calculate.domain.query.CalculateProductCatalogApiQuery;
import com.deepexi.scd.calculate.domain.query.CarbonFootprintQuery;
import com.deepexi.scd.calculate.remote.basic.CarbonProductRemote;
import com.deepexi.scd.calculate.remote.calculate.CalculateProductCatalogRemote;
import com.deepexi.scd.calculate.service.CarbonFootprintService;
import com.deepexi.spa.commons.data.PageBean;
import com.deepexi.spa.commons.data.Payload;
import com.deepexi.spa.commons.utils.CollectionUtils;
import com.google.api.client.util.Lists;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import java.util.Collection;
import java.util.List;
import java.util.stream.Collectors;
import java.util.stream.Stream;
import org.apache.commons.lang3.math.NumberUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

@RestController
@Api(tags={"产品类别"})
@RequestMapping(value={"/admin-api/v1/calculateProductCatalog"})
public class CalculateProductCatalogRemoteController {
    @Autowired
    private CalculateProductCatalogRemote calculateProductCatalogRemote;
    @Autowired
    private CarbonProductRemote productRemote;
    @Autowired
    private CarbonFootprintService carbonFootprintService;

    @ApiOperation(value="产品类别树")
    @GetMapping(value={"/tree"})
    public Payload<PageBean<CalculateProductCatalogApiDTO>> findTree(CalculateProductCatalogApiQuery query) {
        List list = (List)this.calculateProductCatalogRemote.findTree(new CalculateProductCatalogApiQuery()).getPayload();
        if (CollectionUtils.isEmpty((Collection)list)) {
            return Payload.ok((Object)Lists.newArrayList());
        }
        List result = list.stream().filter(item -> CollectionUtils.isNotEmpty((Collection)item.getChildren())).collect(Collectors.toList());
        return Payload.ok(result);
    }

    @ApiOperation(value="产品类别树-已有的碳足迹")
    @GetMapping(value={"/footprintTree"})
    public Payload<PageBean<CalculateProductCatalogApiDTO>> findUsedTree(CalculateProductCatalogApiQuery query) {
        CarbonFootprintQuery ftQuery = new CarbonFootprintQuery();
        List productIds = this.carbonFootprintService.findList(ftQuery).stream().map(i -> i.getProductId()).distinct().collect(Collectors.toList());
        CarbonProductApiQuery apiQuery = new CarbonProductApiQuery();
        apiQuery.setIdList(productIds);
        List productList = (List)this.productRemote.findList(apiQuery).getPayload();
        List cataList = productList.stream().flatMap(i -> this.splitCatalogId(i.getCategoryPath())).distinct().collect(Collectors.toList());
        query.setIdList(cataList);
        List list = (List)this.calculateProductCatalogRemote.findTree(query).getPayload();
        if (CollectionUtils.isEmpty((Collection)list)) {
            return Payload.ok((Object)Lists.newArrayList());
        }
        List result = list.stream().filter(item -> CollectionUtils.isNotEmpty((Collection)item.getChildren())).collect(Collectors.toList());
        return Payload.ok(result);
    }

    Stream<Long> splitCatalogId(String catalogPath) {
        String[] split = catalogPath.split(",");
        return Stream.of(split).filter(i -> NumberUtils.isParsable(i)).map(i -> NumberUtil.parseLong((String)i));
    }
}

